#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <ctype.h>


/* GRUPA A **********************************************************************************************************************************/

#ifdef __GRUPA_A__

double aritmeticka(double x1, double x2, double x3, double x4){
    return (x1 + x2 + x3 + x4) / 4.0;
}

double geometrijska(double x1, double x2, double x3, double x4){
    return pow(x1 * x2 * x3 * x4, 0.25);
}

/* pretpostavit cemo da se su elementi nenegativni, kako bi se geom. sredina mogla racunati */
int usrednjen(double** A, int m, int n, int i, int j){
    return geometrijska(A[0][j], A[m-1][j], A[i][0], A[i][n-1]) < A[i][j] && A[i][j] < aritmeticka(A[0][j], A[m-1][j], A[i][0], A[i][n-1]);
}


typedef double elementtype;
#define test usrednjen
const char inputformat[] = " %lg ";
const char outputformat[] = " %g ";

#endif

/********************************************************************************************************************************************/


/* GRUPA B **********************************************************************************************************************************/

#ifdef __GRUPA_B__

int samoglasnik(char x){
    x = tolower(x);
    return  x == 'a' || x == 'e' || x == 'i' || x == 'o' || x == 'u';
}

int suglasan(char** A, int m, int n, int i, int j){
    return !(samoglasnik(A[0][j]) || samoglasnik(A[m-1][j]) || samoglasnik(A[i][0]) || samoglasnik(A[i][n-1]));
}

typedef char elementtype;
#define test suglasan
const char inputformat[] = " %c ";
const char outputformat[] = " %c ";

#endif

/********************************************************************************************************************************************/


/* GRUPA C **********************************************************************************************************************************/

#ifdef __GRUPA_C__

int suma13(int x){
    int suma = 0;
    if(x < 0) x = -x;
    while(x){
        suma += x % 13;
        x /= 13;
    }
    return  suma;
}

int cudan(int** A, int m, int n, int i, int j){
    return A[i][j] == suma13(A[0][j]) || A[i][j] == suma13(A[m-1][j]) || A[i][j] == suma13(A[i][0]) || A[i][j] == suma13(A[i][n-1]);
}

typedef int elementtype;
#define test cudan
const char inputformat[] = " %d ";
const char outputformat[] = " %d ";

#endif

/********************************************************************************************************************************************/


/* GRUPA D **********************************************************************************************************************************/

#ifdef __GRUPA_D__

int neprost(int x){
    int d;
    if(x < 2) return 1;
    for(d = 2; d < x; ++d)
        if(x % d == 0) return 1;
    return  0;
}

int kompliciran(int** A, int m, int n, int i, int j){
    return neprost(A[0][j]) && neprost(A[m-1][j]) && neprost(A[i][0]) && neprost(A[i][n-1]);
}

typedef int elementtype;
#define test kompliciran
const char inputformat[] = " %d ";
const char outputformat[] = " %d ";

#endif

/********************************************************************************************************************************************/



/* b) dio zadatka za sve grupe */



elementtype** alociraj_matricu(int m, int n){
    elementtype** matrica;
    int i;

    if( !(matrica = malloc(m*sizeof(elementtype*))) ) return NULL;
    for(i = 0; i < m; ++i){
        if( !(matrica[i] = malloc(n*sizeof(elementtype))) ){
            do{
                free(matrica[--i]);
            }while(i);
            free(matrica);
            return NULL;
        }
    }

    return matrica;
}

void ucitaj_matricu(FILE* in, elementtype** A, int m, int n){
    int i,j;
    for(i = 0; i < m; ++i)
        for(j=0; j < n; ++j)
            fscanf(in, inputformat, &A[i][j]);
}


int main(){
    char input[255];
    char output[255];
    FILE* in = NULL;
    FILE* out = NULL;
    elementtype** matrica;
    int m, n, i, j, k;
    int brojac;
    elementtype* izlazno_polje;

    scanf("%s", input);
    scanf("%s", output);

    /* otvori datoteku za citanje */
    if( !(in = fopen(input, "rt")) ){
        fprintf(stderr, "Greska pri otvaranju datoteke %s\n", input);
        return 1;
    }

    /* ucitaj dimenzije matrice */
    fscanf(in, "%d %d", &m, &n);


    if( !(matrica = alociraj_matricu(m,n)) ){
        fprintf(stderr, "Greska pri alokaciji memorije\n");
        fclose(in);
        return 2;
    }

    ucitaj_matricu(in, matrica, m, n);
    fclose(in);

    /* prebroji koliko ima interesantnih elemenata matrice */
    brojac = 0;
    for(i = 0; i < m; ++i)
        for(j=0; j < n; ++j)
            if(test(matrica, m, n, i, j)) ++brojac;

    /* kreiraj polje tih elemenata */
    if( !(izlazno_polje = malloc(brojac*sizeof(elementtype))) ){
        fprintf(stderr, "Greska pri alokaciji memorije\n");
        return 3;
    }
    k = 0;
    for(i = 0; i < m; ++i)
        for(j=0; j < n; ++j)
            if(test(matrica, m, n, i, j)) izlazno_polje[k++] = matrica[i][j];

    /* matrica nam vise ne treba, mozemo dealocirati */
    for(i = 0; i < m; ++i) free(matrica[i]);
    free(matrica);

    /* sortiraj polje */
    for(i = 0; i < brojac; ++i)
        for(j=i+1; j < brojac; ++j)
            if(izlazno_polje[i] > izlazno_polje[j]){
                elementtype tmp = izlazno_polje[i];
                izlazno_polje[i] = izlazno_polje[j];
                izlazno_polje[j] = tmp;
            }

    /* otvori datoteku za pisanje */
    if( !(out = fopen(output, "wt")) ){
        fprintf(stderr, "Greska pri otvaranju datoteke %s\n", output);
        return 4;
    }

    /* ispisi sortirano polje */
    for(i = 0; i < brojac; ++i) fprintf(out, outputformat, izlazno_polje[i]);

    free(izlazno_polje);
    fclose(out);

    return 0;
}






















