#ifdef __GRUPA_A__

typedef struct Alpha {
    int* array;
    unsigned long size;
    int i;
    struct Alpha* next;
} alpha;

int suma(int* a, unsigned long n){
    int i, s=0;
    for(i=0; i<n; ++i) s += a[i];
    return s;
}

int compare(const alpha* a1, consr alpha* a2){
    int s1 = suma(a1->array, a1->size);
    int s2 = suma(a2->array, a2->size);
    if(s1 != s2) return s1 - s2;
    return a1->i - a2->i;
}

unsigned long count(alpha* first){
    unsigned long cnt = 0;
    while(first){
        if(first->i >= 0 && first->i < first->size && first->array[first->i] % 2 == 0) ++cnt;
        first = first->next;
    }
    return cnt;
}


void swap(alpha* p, alpha* q){
    alpha tmp;
    tmp.array = p->array;
    tmp.size  = p->size;
    tmp.i     = p->i;
    p->array = q->array;
    p->size  = q->size;
    p->i     = q->i;
    q->array = tmp.array;
    q->size  = tmp.size;
    q->i     = tmp.i;
}

void sort(alpha* first){
    alpha* p = NULL;
    alpha* q = NULL;
    for(p = first; p != NULL; p = p->next)
        for(q = p->next; q != NULL; q = q->next)
            if(compare(p,q) < 0) swap(p,q);
}

#endif



#ifdef __GRUPA_B__

typedef struct Beta {
    double* array;
    unsigned long size;
    int j;
    struct Beta* next;
} beta;

double produkt(double* a, unsigned long n){
    int i;
    double s=1.0;
    for(i=0; i<n; ++i) s *= a[i];
    return s;
}

int compare(const beta* b1, const beta* b2){
    double p1, p2;
    if(b1->size < b2->size) return -1;
    if(b1->size > b2->size) return 1;
    p1 = produkt(b1->array, b1->size);
    p2 = produkt(b2->array, b2->size);
    if(p1 < p2) return -1;
    if(p1 > p2) return 1;
    return 0;
}

unsigned long count(beta* first){
    unsigned long cnt = 0;
    while(first){
        if(first->j >= 0 && first->j < first->size && first->array[first->j] > -352.5) ++cnt;
        first = first->next;
    }
    return cnt;
}


void swap(beta* p, beta* q){
    beta tmp;
    tmp.array = p->array;
    tmp.size  = p->size;
    tmp.j     = p->j;
    p->array = q->array;
    p->size  = q->size;
    p->j     = q->j;
    q->array = tmp.array;
    q->size  = tmp.size;
    q->j     = tmp.j;
}

void sort(beta* first){
    beta* p = NULL;
    beta* q = NULL;
    for(p = first; p != NULL; p = p->next)
        for(q = p->next; q != NULL; q = q->next)
            if(compare(p,q) < 0) swap(p,q);
}

#endif




#ifdef __GRUPA_C__

typedef struct Gamma {
    long* array;
    unsigned long size;
    int k;
    struct Gamma* next;
} gamma;


long max(long* a, unsigned long n){
    int i;
    long m=a[0];
    for(i=1; i<n; ++i)
        if(a[i] > m) m = a[i];
    return m;
}

long compare(const gamma* g1, const gamma* g2){
    long m1 = max(g1->array, g1->size);
    long m2 = max(g2->array, g2->size);
    if(m1 != m2) return m1 - m2;
    return g2->k - g1->k;
}

unsigned long count(gamma* first){
    unsigned long cnt = 0;
    while(first){
        if(first->k >= 0 && first->k < first->size && first->array[first->k] % 17 == 0) ++cnt;
        first = first->next;
    }
    return cnt;
}


void swap(gamma* p, gamma* q){
    gamma tmp;
    tmp.array = p->array;
    tmp.size  = p->size;
    tmp.k     = p->k;
    p->array = q->array;
    p->size  = q->size;
    p->k     = q->k;
    q->array = tmp.array;
    q->size  = tmp.size;
    q->k     = tmp.k;
}

void sort(gamma* first){
    gamma* p = NULL;
    gamma* q = NULL;
    for(p = first; p != NULL; p = p->next)
        for(q = p->next; q != NULL; q = q->next)
            if(compare(p,q) < 0) swap(p,q);
}

#endif


#ifdef __GRUPA_D__

typedef struct Delta {
    float* array;
    unsigned long size;
    int L;
    struct Delta* next;
} delta;

float suma(int* a, unsigned long n){
    int i;
    float s=0.0f;
    for(i=0; i<n; ++i) s += a[i];
    return s;
}

int compare(const delta* d1, const delta* d2){
    float s1, s2;
    if(d1->L != d2->L) return d1->L - d2->L;
    s1 = suma(d1->array, d1->size);
    s2 = suma(d2->array, d2->size);
    if(s1 > s2) return 1;
    if(s1 < s2) return -1;
    return 0;
}

unsigned long count(delta* first){
    unsigned long cnt = 0;
    while(first){
        if(first->L >= 0 && first->L < first->size && first->array[first->L] = L) ++cnt;
        first = first->next;
    }
    return cnt;
}


void swap(delta* p, delta* q){
    delta tmp;
    tmp.array = p->array;
    tmp.size  = p->size;
    tmp.L     = p->L;
    p->array = q->array;
    p->size  = q->size;
    p->L     = q->L;
    q->array = tmp.array;
    q->size  = tmp.size;
    q->L     = tmp.L;
}

void sort(delta* first){
    delta* p = NULL;
    delta* q = NULL;
    for(p = first; p != NULL; p = p->next)
        for(q = p->next; q != NULL; q = q->next)
            if(compare(p,q) < 0) swap(p,q);
}

#endif


